/*
 *
 * ATM Switch Viewer - SWView
 * 	by miwa@mt.cs.keio.ac.jp, 1997
 * $Id: swview.h,v 1.2 1997/12/18 01:01:05 miwa Exp $
 *
 */
#ifndef	_SWVIEW_H_
#define	_SWVIEW_H_

typedef struct _swview_window_t
{
    struct _swview_window_t	*next_window;	/* linked list */
    switch_id_t			sw;		/* switch IPaddress */
    char			*name;		/* switch hostname */
    struct _swview_vccline_t	*vccline_list;	/* browser line list */
    FD_swview_switch		*window;	/* window object */
} swview_window_t;

typedef	struct _swview_vccline_t
{
    struct _swview_vccline_t	*next_line;	/* linked list */
    swctl_vcc_table_t		*vcc_table;	/* vcc table */
    char			str[BUFSIZ];	/* strings */
    int				priority;	/* priority (0 = highest) */
    int				line;		/* browser line */
} swview_vccline_t;

typedef struct _swview_status_t
{
    struct _swview_status_t	*next_status;	/* linked list */
    struct _swview_window_t	*window;	/* parent(switch info.) */
    swctl_vcc_table_t		*vcc_table;	/* vcc table */
#define	POLLING_ITEMS	40
    u_int			items[POLLING_ITEMS];	/* history */
    u_int			times[POLLING_ITEMS];	/* history(time) */
    u_int			cells;		/* statistics */
    u_int			max_cells;	/* peak hold */
    u_int			timer;		/* timer */
    FD_swview_status		*status;	/* status object */
} swview_status_t;

typedef	struct _swview_conf_port_t
{
    struct _swview_conf_port_t	*next;		/* linked list */
    swctl_vport_t	vport;			/* vport */
    char	       	peer[13];		/* peer hostname */
} swview_conf_port_t;

typedef struct _swview_conf_path_t
{
    struct _swview_conf_path_t	*next;		/* linked list */
    int			in;
    int			out;
    int			priority;
    char		color[5];
    char		status[33];
} swview_conf_path_t;

typedef struct _swview_conf_upc_t
{
    struct _swview_conf_upc_t	*next;		/* linked list */
    int			type;
    int			priority;
    char		color[5];
    char		status[33];
} swview_conf_upc_t;

#define	SNMP_COMMUNITY_MAX_LEN	64
typedef struct _swview_conf_table_t
{
    struct _swview_conf_table_t	*next_table;	/* linked list */
    switch_id_t			sw;		/* switch IPaddress */
    u_char			set_community[SNMP_COMMUNITY_MAX_LEN+1];
    u_char			get_community[SNMP_COMMUNITY_MAX_LEN+1];
    struct _swview_conf_port_t	*port;		/* port table */
    struct _swview_conf_path_t	*path;		/* path table */
    struct _swview_conf_upc_t	*upc;		/* upc table */
} swview_conf_table_t;

typedef	struct _swview_port_table_t
{
    swctl_vport_t	vport;			/* vport */
    char		*port;			/* real portname */
} swview_port_table_t;

#define	TRAFFIC_POLLING_TIMER	1

#define	MAX_PRIORITY		10

#define	SWVIEW_CONF_SWITCH	0
#define	SWVIEW_CONF_PORT	1
#define	SWVIEW_CONF_PATH	2
#define	SWVIEW_CONF_UPC		3
#define	SWVIEW_CONF_COMMUNITY	4

#define	SWVIEW_CONF_UPC_PCR01	1
#define	SWVIEW_CONF_UPC_SCR01	2
#define	SWVIEW_CONF_UPC_MBS01	3
#define	SWVIEW_CONF_UPC_PCR0	4
#define	SWVIEW_CONF_UPC_SCR0	5
#define	SWVIEW_CONF_UPC_MBS0	6
#define	SWVIEW_CONF_UPC_CDVT	7
#define	SWVIEW_CONF_UPC_ACT	8
#define	SWVIEW_CONF_UPC_AAL5EPD	9

#define	SWVIEW_CREATE_ACT	1
#define	SWVIEW_RELEASE_ACT	2
#define	SWVIEW_MODIFY_ACT	3
#define	SWVIEW_REDIRECT_ACT	4

#define	PORT_1A1	0
#define	PORT_1A2	1
#define	PORT_1A3	2
#define	PORT_1A4	3
#define	PORT_1B1	8
#define	PORT_1B2	9
#define	PORT_1B3	10
#define	PORT_1B4	11
#define	PORT_1C1	16
#define	PORT_1C2	17
#define	PORT_1C3	18
#define	PORT_1C4	19
#define	PORT_1D1	24
#define	PORT_1D2	25
#define	PORT_1D3	26
#define	PORT_1D4	27
#define	PORT_CTRL	56

static	swview_port_table_t port_table[] = {{0, "1A1"}, {1, "1A2"}, {2, "1A3"}, {3, "1A4"}, {8, "1B1"}, {9, "1B2"}, {10, "1B3"}, {11, "1B4"}, {16, "1C1"}, {17, "1C2"}, {18, "1C3"}, {19, "1C4"}, {56, "1CTL"}, {0, "1a1"}, {1, "1a2"}, {2, "1a3"}, {3, "1a4"}, {8, "1b1"}, {9, "1b2"}, {10, "1b3"}, {11, "1b4"}, {16, "1c1"}, {17, "1c2"}, {18, "1c3"}, {19, "1c4"}, {56, "1ctl"}, {-1, ""}};

/* swview_main.c */

void swview_open_act __P((FL_OBJECT *ob, long data));
void swview_exit_act __P((FL_OBJECT *ob, long data));
void swview_vcc_act __P((FL_OBJECT *ob, long data));
void swview_mon_act __P((FL_OBJECT *ob, long data));
void swview_polling_act __P((FL_OBJECT *ob, long data));
void swview_dismiss_act __P((FL_OBJECT *ob, long data));
void swview_operation_act __P((FL_OBJECT *ob, long data));
void swview_add_act __P((FL_OBJECT *ob, long data));
void swview_delete_act __P((FL_OBJECT *ob, long data));
void swview_modify_act __P((FL_OBJECT *ob, long data));
void swview_redirect_act __P((FL_OBJECT *ob, long data));
void swview_refresh_act __P((FL_OBJECT *ob, long data));
void swview_close_act __P((FL_OBJECT *ob, long data));
void swview_trap_act __P((int sockfd, void *data));
int main __P((int argc, char *argv[], char *envp[]));

/* swview_tools.c */

int swview_fill_vccline __P((switch_id_t sw, FD_swview_switch
			     *fd_swview_switch, 
			     swview_vccline_t *swview_vccline_list));
int swview_alert_show __P((char *notion));
int swview_yesno_show __P((char *notion));
int swview_swctl_error __P((int val, char *name));
swview_window_t *swview_search_window __P((switch_id_t sw));
swview_status_t *swview_search_status __P((switch_id_t sw,
					   swctl_vcc_table_t *vcc_table));
swview_window_t *swview_search_parent_window __P((FL_OBJECT *ob));
swview_status_t *swview_search_parent_stauts __P((FL_OBJECT *ob));
int free_vccline_list __P((swview_vccline_t *swview_vccline_list));
swctl_vcc_table_t *copy_vcc_table __P((swctl_vcc_table_t *vcc_table));
int swview_get_vcc_paramters __P((swview_window_t *swview_window,
				  FD_swview_vcc *fd_vcc_window,
				  swctl_addr_t *in, swctl_addr_t *out,
				  swctl_param_t *param));
void swview_fill_vcc_paramters __P((swview_window_t *swview_window,
				    FD_swview_vcc *fd_vcc_window,
				    swctl_addr_t *in, swctl_addr_t *out,
				    swctl_param_t *param));

/* swview_conf.c */

int swview_conf_parse __P((char *conf_file));
int str2op __P((char *str));
int str2upctype __P((char *str));
char *search_portname __P((int vport));
int search_vport __P((char *portname));
char *search_peername __P((switch_id_t sw, int vport));
u_char *search_set_community __P((switch_id_t sw));
u_char *search_get_community __P((switch_id_t sw));
swview_vccline_t *swview_set_vccline_list __P((switch_id_t sw,
					       FD_swview_switch
					       *fd_swview_switch, 
					       swctl_vcc_table_t
					       *vcc_table_list));

#endif	/* _SWVIEW_H_ */
