/*
 *
 * ATM Switch Viewer - SWView
 * 	by miwa@mt.cs.keio.ac.jp, 1997
 * $Id: swview_tools.c,v 1.1 1997/12/17 02:10:47 miwa Exp $
 *
 */

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <stdlib.h>

#include "X11/forms.h"
#include "swctl.h"
#include "swview_fd.h"
#include "swview.h"

extern swview_window_t *swview_window_list;
extern swview_status_t *swview_status_list;

int swview_fill_vccline(switch_id_t sw, FD_swview_switch *fd_swview_switch,
			swview_vccline_t *swview_vccline_list)
{
    int i;
    int line = 1;

    swview_vccline_t *swview_vccline;

    for(i = 0; i <= MAX_PRIORITY; i++) {

	for(swview_vccline = swview_vccline_list; swview_vccline;
	    swview_vccline = swview_vccline->next_line) {

	    if(swview_vccline->priority == i)  {
		fl_add_browser_line(fd_swview_switch->swview_vcc_browser,
				    swview_vccline->str);
		swview_vccline->line = line++;
	    }
	}
    }
}

int swview_alert_show(char *notion)
{
    FD_swview_alert *fd_swview_alert;
    
    fl_deactivate_all_forms();

    fd_swview_alert = create_form_swview_alert();
    fl_set_object_label(fd_swview_alert->swview_alert_text, notion);
    fl_show_form(fd_swview_alert->swview_alert,
		 FL_PLACE_MOUSE, FL_TRANSIENT, "Alert");
    while( fl_do_forms() != fd_swview_alert->swview_ok_button )
      ;
    fl_hide_form(fd_swview_alert->swview_alert);
    fl_free_form(fd_swview_alert->swview_alert);

    fl_activate_all_forms();
}

int swview_yesno_show(char *notion)
{
    int val;
    FD_swview_yesno *fd_swview_yesno;

    fl_deactivate_all_forms();
    
    fd_swview_yesno = create_form_swview_yesno();
    fl_set_object_label(fd_swview_yesno->swview_question_text, notion);
    fl_show_form(fd_swview_yesno->swview_yesno,
		 FL_PLACE_MOUSE, FL_TRANSIENT,"Question");

    if( fl_do_forms() == fd_swview_yesno->swview_ok_button)
      val = 1;
    else
      val = 0;

    fl_hide_form(fd_swview_yesno->swview_yesno);
    fl_free_form(fd_swview_yesno->swview_yesno);

    fl_activate_all_forms();

    return(val);
}

int swview_swctl_error(int val, char *name)
{
    char notion_buf[BUFSIZ];

    switch(val) {
      case SWCTL_SWITCH_FAILURE:
	sprintf(notion_buf, "Switch SNMP Failure (switch SNMP Agent broken?).");
	break;
	
      case SWCTL_VCC_FAILURE:
	sprintf(notion_buf, "This VCC already established or not established yet.");
	break;

      case SWCTL_UPC_FAILURE:
	sprintf(notion_buf, "UPC failed (cannot assign enough resource).");
	break;

      case SWCTL_NETWORK_FAILURE:
	sprintf(notion_buf, "Switch %s maybe down or unreachable.", name);
	break;
	
      default:
	sprintf(notion_buf, "Sorry, serious error had occured.");
	break;
    }
    swview_alert_show(notion_buf);
}

int swview_vcc_change_upc(FD_swview_vcc *fd_vcc_window, int val)
{

    if(val) 
      {
	fl_activate_object(fd_vcc_window->pcr01);
	fl_set_object_lcol(fd_vcc_window->pcr01, FL_BLACK);
	fl_activate_object(fd_vcc_window->scr01);
	fl_set_object_lcol(fd_vcc_window->scr01, FL_BLACK);
	fl_activate_object(fd_vcc_window->mbs01);
	fl_set_object_lcol(fd_vcc_window->mbs01, FL_BLACK);
	fl_activate_object(fd_vcc_window->pcr0);
	fl_set_object_lcol(fd_vcc_window->pcr0, FL_BLACK);
	fl_activate_object(fd_vcc_window->scr0);
	fl_set_object_lcol(fd_vcc_window->scr0, FL_BLACK);
	fl_activate_object(fd_vcc_window->mbs0);
	fl_set_object_lcol(fd_vcc_window->mbs0, FL_BLACK);
	fl_activate_object(fd_vcc_window->cdvt);
	fl_set_object_lcol(fd_vcc_window->cdvt, FL_BLACK);
	fl_activate_object(fd_vcc_window->upc_act_drop);
	fl_set_object_lcol(fd_vcc_window->upc_act_drop, FL_BLACK);
	fl_activate_object(fd_vcc_window->upc_act_tag);
	fl_set_object_lcol(fd_vcc_window->upc_act_tag, FL_BLACK);
	fl_activate_object(fd_vcc_window->vcc_aal5epd_on);
	fl_set_object_lcol(fd_vcc_window->vcc_aal5epd_on, FL_BLACK);
	fl_activate_object(fd_vcc_window->vcc_aal5epd_off);
	fl_set_object_lcol(fd_vcc_window->vcc_aal5epd_off, FL_BLACK);
	fl_set_object_lcol(fd_vcc_window->upc_act_text, FL_BLACK);
	fl_set_object_lcol(fd_vcc_window->aal5epd_text, FL_BLACK);
      }
    else {
	fl_deactivate_object(fd_vcc_window->pcr01);
	fl_set_object_lcol(fd_vcc_window->pcr01, FL_TOP_BCOL);
	fl_deactivate_object(fd_vcc_window->scr01);
	fl_set_object_lcol(fd_vcc_window->scr01, FL_TOP_BCOL);
	fl_deactivate_object(fd_vcc_window->mbs01);
	fl_set_object_lcol(fd_vcc_window->mbs01, FL_TOP_BCOL);
	fl_deactivate_object(fd_vcc_window->pcr0);
	fl_set_object_lcol(fd_vcc_window->pcr0, FL_TOP_BCOL);
	fl_deactivate_object(fd_vcc_window->scr0);
	fl_set_object_lcol(fd_vcc_window->scr0, FL_TOP_BCOL);
	fl_deactivate_object(fd_vcc_window->mbs0);
	fl_set_object_lcol(fd_vcc_window->mbs0, FL_TOP_BCOL);
	fl_deactivate_object(fd_vcc_window->cdvt);
	fl_set_object_lcol(fd_vcc_window->cdvt, FL_TOP_BCOL);
	fl_deactivate_object(fd_vcc_window->upc_act_drop);
	fl_set_object_lcol(fd_vcc_window->upc_act_drop, FL_TOP_BCOL);
	fl_deactivate_object(fd_vcc_window->upc_act_tag);
	fl_set_object_lcol(fd_vcc_window->upc_act_tag, FL_TOP_BCOL);
	fl_deactivate_object(fd_vcc_window->vcc_aal5epd_on);
	fl_set_object_lcol(fd_vcc_window->vcc_aal5epd_on, FL_TOP_BCOL);
	fl_deactivate_object(fd_vcc_window->vcc_aal5epd_off);
	fl_set_object_lcol(fd_vcc_window->vcc_aal5epd_off, FL_TOP_BCOL);
	fl_set_object_lcol(fd_vcc_window->upc_act_text, FL_TOP_BCOL);
	fl_set_object_lcol(fd_vcc_window->aal5epd_text, FL_TOP_BCOL);
    }
}

swview_window_t *swview_search_window(switch_id_t sw)
{
    swview_window_t *swview_window;

    for(swview_window = swview_window_list; swview_window;
	swview_window = swview_window->next_window)
      if(swview_window->sw == sw)
	break;

    return(swview_window);
}

swview_status_t *swview_search_status(switch_id_t sw,
				      swctl_vcc_table_t *vcc_table) 
{
    swview_status_t *swview_status;

    for(swview_status = swview_status_list; swview_status;
	swview_status = swview_status->next_status)
      if( sw == swview_status->window->sw
	 && vcc_table->in == swview_status->vcc_table->in
	 && vcc_table->out == swview_status->vcc_table->out )
	break;

    return(swview_status);
}

swview_window_t *swview_search_parent_window(FL_OBJECT *ob)
{
    swview_window_t *swview_window;
    FD_swview_switch *window;
    
    for(swview_window = swview_window_list; swview_window;
	swview_window = swview_window->next_window) {

	window = swview_window->window;

	if(ob == window->swview_refresh_button)
	  break;
	else if(ob == window->swview_close_button)
	  break;
	else if(ob == window->swview_vcc_browser)
	  break;
    }

    return(swview_window);
}

swview_status_t *swview_search_parent_stauts(FL_OBJECT *ob)
{
    swview_status_t *swview_status;
    FD_swview_status *status;
    
    for(swview_status = swview_status_list; swview_status;
	swview_status = swview_status->next_status) {

	status = swview_status->status;

	if(ob == status->swview_polling_timer)
	  break;
	else if(ob == status->swview_dismiss_button)
	  break;
    }

    return(swview_status);
}

int free_vccline_list(swview_vccline_t *swview_vccline_list)
{
    swview_vccline_t *swview_vccline;
    swview_vccline_t *swview_vccline_tmp;

    for(swview_vccline = swview_vccline_list; swview_vccline;
	swview_vccline_tmp = swview_vccline,
	swview_vccline = swview_vccline->next_line,
	free(swview_vccline_tmp)) {
	free_vcc_table_list(swview_vccline->vcc_table);
    }
    
}	  

swctl_vcc_table_t *copy_vcc_table(swctl_vcc_table_t *vcc_table)
{
    swctl_vcc_table_t *vcc_table_new;

    if(!vcc_table)
      return((swctl_vcc_table_t *)NULL);

    vcc_table_new
      = (swctl_vcc_table_t *)malloc(sizeof(swctl_vcc_table_t));
    vcc_table_new->next_table = (swctl_vcc_table_t *)NULL;
    vcc_table_new->status = vcc_table->status;
    vcc_table_new->in = vcc_table->in;
    vcc_table_new->out = vcc_table->out;
    if(vcc_table->param) {
	vcc_table_new->param
	  = (swctl_param_t *)malloc(sizeof(swctl_param_t));
	memcpy((void *)(vcc_table_new->param), (void *)(vcc_table->param),
	       sizeof(swctl_param_t));
    }
    else {
	vcc_table_new->param = (swctl_param_t *)NULL;
    }

    return(vcc_table_new);
}

void
swview_fill_vcc_paramters(swview_window_t *swview_window,
			  FD_swview_vcc *fd_vcc_window,
			  swctl_addr_t *in, swctl_addr_t *out,
			  swctl_param_t *param) 
{
    char output_buf[BUFSIZ];

    if( in ) {
	fl_set_input(fd_vcc_window->inPort,
		     search_peername(swview_window->sw,
				     ADDR2VPORT(*(in))));
	sprintf(output_buf, "%u", ADDR2VPI(*(in)));
	fl_set_input(fd_vcc_window->inVPI, output_buf);
	sprintf(output_buf, "%u", ADDR2VCI(*(in)));
	fl_set_input(fd_vcc_window->inVCI, output_buf);
    }
    if( out ) {
	fl_set_input(fd_vcc_window->outPort,
		     search_peername(swview_window->sw,
				     ADDR2VPORT(*(out))));
	sprintf(output_buf, "%u", ADDR2VPI(*(out)));
	fl_set_input(fd_vcc_window->outVPI, output_buf);
	sprintf(output_buf, "%u", ADDR2VCI(*(out)));
	fl_set_input(fd_vcc_window->outVCI, output_buf);
    }
    if ( param ) {
	fl_set_button(fd_vcc_window->use_upc_button, 1);
	swview_vcc_change_upc(fd_vcc_window, 1);

	if(param->pcr01 > 0) {
	    sprintf(output_buf, "%u", param->pcr01);
	    fl_set_input(fd_vcc_window->pcr01, output_buf);
	}
	if(param->scr01 > 0) {
	    sprintf(output_buf, "%u", param->scr01);
	    fl_set_input(fd_vcc_window->scr01, output_buf);
	}
	if(param->mbs01 > 0) {
	    sprintf(output_buf, "%u", param->mbs01);
	    fl_set_input(fd_vcc_window->mbs01, output_buf);
	}
	if(param->pcr0 > 0) {
	    sprintf(output_buf, "%u", param->pcr0);
	    fl_set_input(fd_vcc_window->pcr0, output_buf);
	}
	if(param->scr0 > 0) {
	    sprintf(output_buf, "%u", param->scr0);
	    fl_set_input(fd_vcc_window->scr0, output_buf);
	}
	if(param->mbs0 > 0) {
	    sprintf(output_buf, "%u", param->mbs0);
	    fl_set_input(fd_vcc_window->mbs0, output_buf);
	}
	if(param->cdvt > 0) {
	    sprintf(output_buf, "%u", param->cdvt);
	    fl_set_input(fd_vcc_window->cdvt, output_buf);
	}

	if(param->act)
	  fl_set_button(fd_vcc_window->upc_act_tag, 1);
	else
	  fl_set_button(fd_vcc_window->upc_act_drop, 1);

	if(param->aal5epd)
	  fl_set_button(fd_vcc_window->vcc_aal5epd_on, 1);
	else
	  fl_set_button(fd_vcc_window->vcc_aal5epd_off, 1);
    }
    else {
	fl_set_button(fd_vcc_window->use_upc_button, 0);
	swview_vcc_change_upc(fd_vcc_window, 0);
    }
}

int
swview_get_vcc_paramters(swview_window_t *swview_window,
			 FD_swview_vcc *fd_vcc_window,
			 swctl_addr_t *in, swctl_addr_t *out,
			 swctl_param_t *param) 
{
    int tmp_int, stat;
    char notion_buf[BUFSIZ];
    char get_buf[BUFSIZ];

    swctl_vport_t	inPort, outPort;
    swctl_vpi_t		inVPI, outVPI;
    swctl_vci_t		inVCI, outVCI;
    
    /* get filling parameters (input, output, param) */

    sprintf(get_buf, fl_get_input(fd_vcc_window->inPort));
    if( 0 == strlen(get_buf))
      goto NOT_FILL;
    if( 0 > (tmp_int = search_peername_rev(swview_window->sw, get_buf))) {
	fl_set_input(fd_vcc_window->inPort, "");
	goto PARAM_ERROR;
    }
    inPort = tmp_int;

    sprintf(get_buf, fl_get_input(fd_vcc_window->outPort));
    if( 0 == strlen(get_buf) )
      goto NOT_FILL;
    if( 0 > (tmp_int = search_peername_rev(swview_window->sw, get_buf))) {
	fl_set_input(fd_vcc_window->outPort, "");
	goto PARAM_ERROR;
    }
    outPort = tmp_int;

    sprintf(get_buf, fl_get_input(fd_vcc_window->inVPI));
    if( 0 == strlen(get_buf) )
      goto NOT_FILL;
    if( 0 > (tmp_int = atoi(get_buf))) {
	fl_set_input(fd_vcc_window->inVPI, "");
	goto PARAM_ERROR;
    }
    inVPI = tmp_int;

    sprintf(get_buf, fl_get_input(fd_vcc_window->outVPI));
    if( 0 == strlen(get_buf) )
      goto NOT_FILL;
    if( 0 > (tmp_int = atoi(get_buf))) {
	fl_set_input(fd_vcc_window->outVPI, "");
	goto PARAM_ERROR;
    }
    outVPI = tmp_int;

    sprintf(get_buf, fl_get_input(fd_vcc_window->inVCI));
    if( 0 == strlen(get_buf) )
      goto NOT_FILL;
    if( 0 > (tmp_int = atoi(get_buf))) {
	fl_set_input(fd_vcc_window->inVCI, "");
	goto PARAM_ERROR;
    }
    inVCI = tmp_int;

    sprintf(get_buf, fl_get_input(fd_vcc_window->outVCI));
    if( 0 == strlen(get_buf) )
      goto NOT_FILL;
    if( 0 > (tmp_int = atoi(get_buf))) {
	fl_set_input(fd_vcc_window->outVCI, "");
	goto PARAM_ERROR;
    }
    outVCI = tmp_int;

    if( 1 == fl_get_button(fd_vcc_window->use_upc_button) ) {

	sprintf(get_buf, fl_get_input(fd_vcc_window->pcr01));
	if( 0 == strlen(get_buf) )
	  param->pcr01 = 0;
	if( 0 > (tmp_int = atoi(get_buf)))
	  goto PARAM_ERROR;
	param->pcr01 = tmp_int;
		
	sprintf(get_buf, fl_get_input(fd_vcc_window->scr01));
	if( 0 == strlen(get_buf) )
	  param->scr01 = 0;
	if( 0 > (tmp_int = atoi(get_buf)))
	  goto PARAM_ERROR;
	param->scr01 = tmp_int;

	sprintf(get_buf, fl_get_input(fd_vcc_window->mbs01));
	if( 0 == strlen(get_buf) )
	  param->mbs01 = 0;
	if( 0 > (tmp_int = atoi(get_buf)))
	  goto PARAM_ERROR;
	param->mbs01 = tmp_int;

	sprintf(get_buf, fl_get_input(fd_vcc_window->pcr0));
	if( 0 == strlen(get_buf) )
	  param->pcr0 = 0;
	if( 0 > (tmp_int = atoi(get_buf)))
	  goto PARAM_ERROR;
	param->pcr0 = tmp_int;

	sprintf(get_buf, fl_get_input(fd_vcc_window->scr0));
	if( 0 == strlen(get_buf) )
	  param->scr0 = 0;
	if( 0 > (tmp_int = atoi(get_buf)))
	  goto PARAM_ERROR;
	param->scr0 = tmp_int;

	sprintf(get_buf, fl_get_input(fd_vcc_window->mbs0));
	if( 0 == strlen(get_buf) )
	  param->mbs0 = 0;
	if( 0 > (tmp_int = atoi(get_buf)))
	  goto PARAM_ERROR;
	param->mbs0 = tmp_int;

	sprintf(get_buf, fl_get_input(fd_vcc_window->cdvt));
	if( 0 == strlen(get_buf) )
	  param->cdvt = 0;
	if( 0 > (tmp_int = atoi(get_buf)))
	  goto PARAM_ERROR;
	param->cdvt = tmp_int;

	param->act =
	  fl_get_button(fd_vcc_window->upc_act_tag);
	param->aal5epd =
	  fl_get_button(fd_vcc_window->vcc_aal5epd_on);
	
    }
    else {
	bzero((void *)param, sizeof(swctl_param_t));
    }
	    
    *(in) = ATM2ADDR(inPort, inVPI, inVCI);
    *(out) = ATM2ADDR(outPort, outVPI, outVCI);
    return(1);

NOT_FILL:
    sprintf(notion_buf, "Too few parameters. (not filled)");
    swview_alert_show(notion_buf);
    return(0);

PARAM_ERROR:
    sprintf(notion_buf, "Wrong parameter(s).");
    swview_alert_show(notion_buf);
    return(0);
}
